#ifndef __mVES__mvesRectangleSource__
#define __mVES__mvesRectangleSource__


#include "vtkPolyDataAlgorithm.h"

#include "vtkFiltersSourcesModule.h"


class mvesRectangleSource : public vtkPolyDataAlgorithm {

public:
    static mvesRectangleSource *New();
    vtkTypeMacro(mvesRectangleSource,vtkPolyDataAlgorithm);
    
    vtkSetVector3Macro(Center,double);
    vtkGetVectorMacro(Center,double,3);
    
    vtkGetVectorMacro(S1,double,3);
    vtkGetVectorMacro(S2,double,3);

    void SetWidth(double w);
    double GetWidth();
    
    void SetHeight(double l);
    double GetHeight();
    
    // Rotate with angle alpha (degrees) around normal vector at center
    void rotate(double alpha);
    
    // Rotate with angle alpha (degrees) around given rotation axis
    void rotate(double alpha, double axis[3]);
    
    // set orientation
    // s1: direction of side one
    // v: vector in direction of side two
    void setOrientation(double s1[3], double v[3]);
    
    // Scale around center
    void scale(double s);
    
    // Translate
    void translate(double dx, double dy, double dz);
    
protected:
    mvesRectangleSource();
    ~mvesRectangleSource() {};
    
    int RequestData(vtkInformation *, vtkInformationVector **, vtkInformationVector *);

    double Center[3];
    double S1[3];
    double S2[3];
};


#endif
