#ifndef mVES_mvesRenderer_h
#define mVES_mvesRenderer_h

#include "vesRenderer.h"
#include "vesActor.h"
#include "vesCamera.h"
#include "vesViewport.h"

#include "mvesPolyDataMapper.h"

#include <set>

using namespace std;

/// description:
/// Renderer implementation which updates mvesPolyDataMapper objects.
class mvesRenderer : public vesRenderer {
    
private:
    set<vesSharedPtr<vesActor> > actors;
    
public:
    
    void update() {
        for(std::set<vesSharedPtr<vesActor> >::iterator it = this->actors.begin(); it != this->actors.end(); it++) {
            mvesPolyDataMapper* m = dynamic_cast<mvesPolyDataMapper*>((*it)->mapper().get());
            
            if(m != NULL) {
                m->update();
            }
        }
    }
    
    virtual void render() {
        update();
        vesRenderer::render();
    }
    
    virtual void addActor(vesSharedPtr<vesActor> actor) {
        this->actors.insert(actor);
        vesRenderer::addActor(actor);
    }
    
    virtual void removeActor(vesSharedPtr<vesActor> actor) {
        this->actors.erase(actor);
        vesRenderer::removeActor(actor);
    }
};

#endif
